# fis3 http 部署插件 (增强版)

FIS 提供本地部署以及远程upload部署能力。

## 安装

全局安装或者本地安装都可以。

```
npm install fis3-deploy-http-push-plus
```

## 使用方法

```javascript
fis.match('**', {
    deploy: fis.plugin('http-push-plus', {
        //如果配置了receiver，fis会把文件逐个post到接收端上
        receiver: 'http://www.example.com:8080/receiver.php?debug=true',
        //这个参数会跟随post请求一起发送
        to: '/home/fis/www',
        // 附加参数, 后端通过 $_POST['xx'] 获取
        data: {
            token : 'abcdefghijk',
            user : 'maxming',
            uid : 1
        }
    })
})
```

## 另类使用方法 ( 比如: 部署时需要 token 输入 )

```javascript
const crypto = require('crypto');
const readlineSync = require('readline-sync');
fis.match('**', {
  deploy: [
    function (options, modified, total, next) {
      var token = readlineSync.question('\r\n请输入授权token : ', {
        hideEchoBack: true
      });
      if (!token) {
        return false;
      }
      var md5 = crypto.createHash('md5');
      fis.set('project.token', md5.update(token).digest('hex'));
      next();
    },
    function () {
      arguments[0] = {
        //如果配置了receiver，fis会把文件逐个post到接收端上
        receiver: 'http://maxtt.cc/receiver.php?debug=false',
        // receiver: 'http://127.0.0.1/receiver.php',
        //这个参数会跟随post请求一起发送
        to: '/home/maxming/www/wb',
        // to: '/Users/maxming/www/wb',
        // 附加参数, 后端通过 $_POST['xx'] 获取
        data: {
          token: fis.get('project.token')
        }
      };
      require('fis3-deploy-http-push-plus').apply(this, arguments);
    }
  ]
});
```
